      /*
       *  aurora.cpp
       *
       *  Copyright (c) 2007 by Kuscsik Peter <kuscsikp@gmail.com>
       *
       *  This program is free software; you can redistribute it and/or modify
       *  it under the terms of the GNU General Public License as published by
       *  the Free Software Foundation; either version 2 of the License, or
       *  (at your option) any later version.
       *
       *  This program is distributed in the hope that it will be useful,
       *  but WITHOUT ANY WARRANTY; without even the implied warranty of
       *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       *  GNU General Public License for more details.
       *
       *  You should have received a copy of the GNU General Public License
       *  along with this program; if not, write to the Free Software
       *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
       *  USA.
       */ 

#include <string.h>
#include <stdexcept>

#include "aurora.h"

char zero[ ] = {'\0'};

//////////////////////////////////////////////////
/////////Aurora functions/////////////////////////
//////////////////////////////////////////////////
// Creates object & opens the input file
aurora::aurora (char* script_File)
{
	char string[50] = "/usr/share/procbench/";
	if ((File = fopen(script_File, "r")) == NULL) 
		if ((File = fopen(strcat(string,script_File), "r")) == NULL) {
			printf("Script File not found\n");
			return;
			}

	finished=0;
	
	pos_in_line=1;
	line_in_file=1;
	head = NULL;
	last = NULL;
}

#define YES 1
#define NO 0

//FIXME!!! Free up au_data->data
// Executes the script
void aurora::exec_script (char* adress)
{
	pointer=adress;
	sub_pointer=0;

	try {
		while (!finished){								
			read_a_word();
			char command_found=NO;
			if (!finished) {

				if (strcmp (read_word,"RELOAD")==0) {				//set a data value
					//printf("-%s-\n",read_word);
					read_a_word();
					au_data* data = find_data(read_word);			//fixme!!!! (bad name?)
					
					read_data(data);

					command_found=YES;
					}
				if (strcmp (read_word,"ASSIGN")==0) {				//set a data value
					//printf("-%s-\n",read_word);
					read_a_word();
					//printf("%s\n",read_word);
					au_data* data = find_data(read_word);
					int data_add = 0;
					if (data==NULL) {
						data = last;
						data_add = 1;
						last->name = push_the_word();			//set the data name
						}
					

					data->type = read_a_data_type();
					data->size = data->type;
												//FIXME free up memory
					if (last->type==DT_STRING) {				//FIXME redefinition of types!!!
						read_a_string();
						data->data = (char *)malloc(strlen(read_word+1));
						memcpy (data->data,read_word,strlen(read_word));		
						data->data[strlen(read_word)]='\0';	
						}
					else {
						read_a_word();
						static int value;
						sscanf(read_word, "%d", &(value));
						data->data = (char *)malloc(4);
						memcpy (data->data,&value,4);
						
						}

					read_a_string();					//get the comment FIXME (Freemem)
					last->comment = push_the_word();			//FIXME for empty strings


					if (data_add==1){
						if (head==NULL) head = last;
						last->next = new au_data();			//create & set the next pointer
						last = last->next;
					}


					command_found=YES;
					}

				if (strcmp (read_word,"DEF")==0) {				//data to read
					//printf("-%s-\n",read_word);

					if (last==NULL) last = new au_data();
					last->type = read_a_data_type();			//get data type and size
	
					last->size = last->type;
					if (last->type==DT_STRING) {				
						read_a_word();	
						sscanf(read_word, "%d", &(last->size));
						}
	
					read_a_word();						//get the name
					last->name = push_the_word();
	
					read_a_string();					//get the comment
					last->comment = push_the_word();
				
					read_data(last);

					if (head==NULL) head = last;
					last->next = new au_data();				//create & set the next pointer
					last = last->next;
					command_found=YES;
					}

				if (strcmp (read_word,"TRANS")==0) {			//transform decimal value to string
					//printf("-%s-\n",read_word);
					read_a_word();
					au_data* data = find_data(read_word);			//FIXME (free!)

					data->type = read_a_data_type();			//get data type and size
	
					read_a_word();						//check the {

					if (strcmp (read_word,"{")!=0) {
						show_error("'{' is missing");
						}						//FIXME!!!!! any -> any

					int counter = 0;

					read_a_word();		
					while (strcmp (read_word,"}")!=0) {			//unpack data
						counter++;
						if (counter>1024) {				//check for endless loop (bad structure)
							show_error("Endless loop in SETLIST!");
							return;
							}

						static int value;				//FIXME for string

						sscanf(read_word, "%d", &(value));

						read_a_string();

						if (value==data->get_data_int()) {
								data->data = (char *)malloc(strlen(read_word+1));
								memcpy (data->data,read_word,strlen(read_word));		
								data->data[strlen(read_word)]='\0';	
								
							}
						read_a_word();	
						}

					command_found=YES;

					}


				if (read_word[0]=='#') {					//remark
					read_a_word();	
					int counter=0;
					while (read_word[0]!='#') {		
						counter++;
						if (counter>1024) {		
							show_error("Unfinished remark");
							return;
							}
						read_a_word();
						}
					command_found=YES;
					}


				if (strcmp (read_word,"BITLIST")==0) {				//packed data in bits
					//printf("-%s-\n",read_word);

					int data_type = read_a_data_type();			//get data 

					if (data_type==DT_STRING) show_error("Strings are not supported!");


					static unsigned int data_to_unpack = 0;
												//get data to unpack
					memcpy (&data_to_unpack,pointer,data_type /*same as size*/);	

					pointer+=data_type;

					
					int counter=0;

					if (last==NULL) last = new au_data();

					last->data = (char *)malloc(1024);			//alloc memory. FIXME!!!
					last->data[0]='\0';

					last->type=DT_STRING;

					read_a_word();						//get the name
					last->name = push_the_word();

					read_a_string();					//get the comment
					last->comment = push_the_word();
				
						
					read_a_word();						//check the {
					if (strcmp (read_word,"{")!=0) {
						show_error("'{' is missing");
						}

					
					read_a_word();
					while (strcmp (read_word,"}")!=0) {			//unpack data
						counter++;
						if (counter>1024) {				//check for endless loop (bad structure)
							show_error("Endless loop in BITLIST!");
							return;
							}
						static int bit;
						sscanf(read_word, "%d", &(bit));
						last->type = DT_BITLIST;
						read_a_string();
						if (((data_to_unpack >> bit) % 2)==1) {
							if (last->data[0]!='\0') strcat (last->data," ");
							strcat (last->data,read_word);

							}
						read_a_word();	
						}
					command_found=YES;

					if (head==NULL) head = last;
					last->next = new au_data();				//create & set the next pointer
					last = last->next;

					}

				if (strcmp (read_word,"UNPACK")==0) {				//packed data
					//printf("-%s-\n",read_word);

					int data_type = read_a_data_type();			//get data
					if (data_type==DT_STRING) show_error("Strings are not supported!");

					static unsigned int data_to_unpack = 0;
												//get data to unpack
					memcpy (&data_to_unpack,pointer,data_type /*same as size*/);	
					pointer+=data_type;
					read_a_word();	
					if (strcmp (read_word,"{")!=0) {
						show_error("'{' is missing");
						}

					read_a_word();	//!!!!!!

					int counter=0;
					while (strcmp (read_word,"}")!=0) {			//unpack data
						counter++;
						if (counter>1024) {				//check for endless loop (bad structure)
							show_error("Endless loop in UNPACK!");
							return;
							}
						static int left_b, right_b;
						sscanf(read_word, "%d", &(left_b));
						read_a_word();
						sscanf(read_word, "%d", &(right_b));
						if (last==NULL) last = new au_data();
						last->type = read_a_data_type();
						read_a_word();					//get the name
						last->name = push_the_word();			
						read_a_string();				//get the comment
						last->comment = push_the_word();

						last->data = (char *)malloc(4);			//set data value
						(*(int*)last->data)=((data_to_unpack<<(31-right_b))>>(31-right_b))>>left_b;

						if (head==NULL) head = last;
						last->next = new au_data();			//create & set the next pointer
						last = last->next;

						read_a_word();
						}
					command_found=YES;

					}

				if (strcmp (read_word,"ALERT")==0) {				//alert
					read_a_string();
					printf("%s\n",read_word);
					command_found=YES;
					}

				if (strcmp (read_word,"}")==0) {				//ignored
					command_found=YES;
					}

				if (strcmp (read_word,"STOP")==0) {				//stop executing the script
					finished=YES;
					command_found=YES;
					}

				if (strcmp (read_word,"JUMP")==0) {				//jump in data buffer
					static int to;
					read_a_word();
					sscanf(read_word, "%d", &to);
					pointer+=to;
					command_found=YES;
					}

				if (strcmp (read_word,"SUB")==0) {				//subroutine find
					read_a_word();						//ignore everything inside the sub
					while (strcmp (read_word,"RETURN")!=0)
						read_a_word();
					command_found=YES;
										
					}

				if (strcmp (read_word,"IF")==0) {				//condition
					int cond_type=0;
					read_a_word();
					if (strcmp (read_word,"EQ")==0) cond_type=1;		//get condition type
					else if (strcmp (read_word,"NEQ")==0) cond_type=2;
					else if (strcmp (read_word,"G")==0) cond_type=3;
					else if (strcmp (read_word,"GE")==0) cond_type=4;
					else if (strcmp (read_word,"L")==0) cond_type=5;
					else if (strcmp (read_word,"LE")==0) cond_type=6;
					else show_error("Unknown condition type");
					read_a_word();	
					int accept=NO;						
					au_data* data = find_data(read_word);			//FIXME
					if (data->type==DT_STRING) {				//compare data if string
							read_a_string();		
												//FIXME


							if ((cond_type==1) && (strcmp (read_word,data->data)==0)) accept=YES;
							if ((cond_type==2) && (strcmp (read_word,data->data)!=0)) accept=YES;
						}
					else {							//if number
							int read_num;
							read_a_word();	
							sscanf(read_word, "%d", &(read_num));
							if ((cond_type==1) && (read_num == data->get_data_int())) accept=YES;
							if ((cond_type==2) && (read_num != data->get_data_int())) accept=YES;
							if ((cond_type==3) && (data->get_data_int() > read_num)) accept=YES;
							if ((cond_type==4) && (data->get_data_int() >= read_num)) accept=YES;
							if ((cond_type==5) && (data->get_data_int() < read_num)) accept=YES;
							if ((cond_type==6) && (data->get_data_int() <= read_num)) accept=YES;

					}

					command_found=YES;

					read_a_word();	
					if (strcmp (read_word,"{")!=0) {
						show_error("'{' is missing");
						}
					int brack_dep=1;

					if (accept==NO) 
 						while (brack_dep!=0) {					//if condition is not true, skip the code
							read_a_word();
							if (strcmp (read_word,"}")==0) brack_dep--;
							if (strcmp (read_word,"{")==0) brack_dep++;
							}

				}
				if (command_found==NO) show_error("Unknown Command");		//unknown command
			}
		}
	 }
   	catch( char * str ) {
      		show_error(str);
   	}
}

// Read and display information from the chained list
void aurora::show_info ()
{
	au_data* data = head;
	while (data->next!=NULL)  {
		if (data->type <= DT_DWORD)				//number
			printf("%s : %d\n",data->comment, data->get_data_int());
		else							//string
			printf("%s : %s\n",data->comment, data->get_data_string());
		data = data->next;
		}
}

// Get the number of data types
int aurora::read_a_data_type()
{
	read_a_word();
	if (strcmp (read_word,"BYTE")==0) return DT_BYTE;
	else if (strcmp (read_word,"WORD")==0) return DT_WORD;
	else if (strcmp (read_word,"DWORD")==0) return DT_DWORD;
	else if (strcmp (read_word,"STRING")==0) return DT_STRING;
	else show_error("Unknown data type");
}

// Read a word from the script file
void aurora::read_a_word()
{
	if (feof(File)) show_error("No STOP at the end of file");

	int position=1;
	char c;
	while ( ((c=fgetc_s(File))<=' ') && (!feof(File)) );			//ignore whitespaces
	if (feof(File)) {							//end of file?
		finished = 1;
		return;
		}
	read_word[0]=c;

	while ((read_word[position]=fgetc_s(File))>' ') position++;		//read the word

	read_word[position]='\0';
										//GOSUB found
	if (strcmp (read_word,"GOSUB")==0) 
		{
		read_a_word();

		char sub_name[1024];						//get sub name
		memcpy (&sub_name,&read_word,1024);

		if (sub_pointer!=0) show_error("GOSUB/SUB error");

		sub_pointer=ftell(File);					//set sub return pointer
		rewind(File);
		while (1) {
			read_a_word();	
			if (strcmp (read_word,"SUB")==0) 			//find the sub
				{
				read_a_word();
				//printf("%d %s \n",sub_pointer, read_word);
				if (strcmp (read_word,sub_name)==0)		//sub found!
					{
					read_a_word();				//continue from this position
					if (strcmp (read_word,"RETURN")==0) show_error("Empty SUB");
					return;	
					}
				else while (strcmp (read_word,"RETURN")!=0) 
					{
					register int temp_sub_pointer = sub_pointer;
					sub_pointer = 0;
					read_a_word();				//skip bad sub
					sub_pointer = temp_sub_pointer;		// <- prevent bugs in recursive call
					}

				}
			}
		}

		if (strcmp (read_word,"RETURN")==0) {				//exit from sub
			if (sub_pointer!=0) fseek ( File , sub_pointer , SEEK_SET );
			else return;			
			read_a_word();
		//	printf("%d %s \n",sub_pointer, read_word);
			sub_pointer=0;
			}


}

// Read a string from the script file
void aurora::read_a_string()
{
	int position=0;
	char c;

	while ( ((c=fgetc_s(File))!='"') && (!feof(File))) 
		if (c>20) {
			show_error("Bad string");
			finished = 1;
			return;
		}
	if (feof(File)) {
		finished = 1;
		return;
		}


	while ((read_word[position]=fgetc_s(File))!='"') position++;

	read_word[position]='\0';

}

void aurora::show_error (char* error_string)
{
	printf("Error at %d,%d: %s (near to: %s)\n",line_in_file,pos_in_line-1,error_string,read_word);
	abort();				//FIXME!
	finished=YES;
}

int aurora::fgetc_s(FILE *fp)
{
	register int c = fgetc(fp);
	if (sub_pointer!=0) return c;		//inside of subroutine
	pos_in_line++;
	if (c=='\n') {
		line_in_file++;
		pos_in_line=1;
		}
	return c;
}

char* aurora::push_the_word()
{
	int len = strlen(read_word);
	char *string = (char *)malloc(len+1);
	memcpy (string,&read_word,len+1);
	return string;
}

//read data from input buffer
void aurora::read_data(au_data *data)
{
	if (data->type<=DT_DWORD) {				//read a number
		data->data = (char *)malloc(4);
		memset (data->data,'\0',4);

		memcpy (data->data,pointer,data->size);						
		pointer+=data->size;

	} else {						//read a string
		data->data = (char *)malloc(data->size+1);
		memcpy (data->data,pointer,data->size);		
		data->data[data->size]='\0';
		pointer+=data->size;		
	}
}

au_data* aurora::find_data(char *name)
{
	au_data* data = head;
	while (data->next!=NULL)  {
		if (strcmp (name,data->name)==0) return data;
		data = data->next;
		if (data->next == NULL) {
			//show_error("Variable not definied");		
			return NULL;		
			}
		}
}

//////////////////////////////////////////////////
/////////au_data functions////////////////////////
//////////////////////////////////////////////////

au_data::au_data ()
{
	next = NULL;
}

int au_data::get_data_int()
{
	if (data==NULL) return 0;
	else return int(*(int*)data);
}

char* au_data::get_data_string()
{
	if (data==NULL) return zero;
	else return data;
}

