
      /*
       *  aurora.h
       *
       *  Copyright (c) 2007 by Kuscsik Peter <kuscsikp@gmail.com>
       *
       *  This program is free software; you can redistribute it and/or modify
       *  it under the terms of the GNU General Public License as published by
       *  the Free Software Foundation; either version 2 of the License, or
       *  (at your option) any later version.
       *
       *  This program is distributed in the hope that it will be useful,
       *  but WITHOUT ANY WARRANTY; without even the implied warranty of
       *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       *  GNU General Public License for more details.
       *
       *  You should have received a copy of the GNU General Public License
       *  along with this program; if not, write to the Free Software
       *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
       *  USA.
       */ 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>

	//Data types
#define DT_BYTE 1
#define DT_WORD 2
#define DT_DWORD 4
#define DT_BITLIST 11
#define DT_STRING 12

class au_data
{
	public:
		au_data ();
		char type;
		char *name;
		char *comment;
		char *data;	
		char size;	
		//int extra;				//FIXME!!!
		au_data *next;

		int get_data_int();
		char* get_data_string();

};

class aurora
{
	public:
		aurora (char* script_file);
		void exec_script (char* adress);
		void show_info ();

		au_data* find_data(char *name);

		au_data *head;
		au_data *last;
		char *pointer;
	private:

		FILE *File;
		int line_in_file;			//processed lines in script
		int pos_in_line;			//processed chars in a line

		char read_word[1024];			//last read word
		char finished;				//execution finished?

		void read_a_word();			//read word
		void read_a_string();			//read a "word"
		int read_a_data_type();			//read the decimal value of data type

		int sub_pointer;			//return pointer from subroutine

		void show_error (char* error_string);	//display an error message

		char* push_the_word();			//create a zero terminated string from last read word

		void read_data(au_data *data);		//read the value from input buffer and copy into a au_data

		int fgetc_s(FILE *fp);			//modified fgetc with same syntax
};






