/////////////////////////////////////////////////////////////
//			RDTSC
/////////////////////////////////////////////////////////////

#if defined(__i386__)

static __inline__ unsigned long long rdtsc(void)
{
  unsigned long long int x;
     __asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
     return x;
}
#elif defined(__x86_64__)

//typedef unsigned long long int unsigned long long;

static __inline__ unsigned long long rdtsc(void)
{
  unsigned hi, lo;
  __asm__ __volatile__ ("rdtsc" : "=a"(lo), "=d"(hi));
  return ( (unsigned long long)lo)|( ((unsigned long long)hi)<<32 );
}
#elif defined(__ia64__)

static __inline__ unsigned long rdtsc(void)
{
 unsigned long itc;
 asm( "mov %0 = ar.itc" : "=r" (itc) );
 return( itc );
}

#endif

/////////////////////////////////////////////////////////////
//			CPUID
/////////////////////////////////////////////////////////////

#if defined(__i386__) && defined(__PIC__)
/* %ebx may be the PIC register.  */
#define cpuid(level, a, b, c, d)			\
  __asm__ ("xchgl\t%%ebx, %1\n\t"			\
	   "cpuid\n\t"					\
	   "xchgl\t%%ebx, %1\n\t"			\
	   : "=a" (a), "=r" (b), "=c" (c), "=d" (d)	\
	   : "0" (level))
#else
#define cpuid(level, a, b, c, d)			\
  __asm__ ("cpuid\n\t"					\
	   : "=a" (a), "=b" (b), "=c" (c), "=d" (d)	\
	   : "0" (level))
#endif

