
      /*
       *  mem_test.cpp
       *
       *  Copyright (c) 2007 by Kuscsik Peter <kuscsikp@gmail.com>
       *
       *  This program is free software; you can redistribute it and/or modify
       *  it under the terms of the GNU General Public License as published by
       *  the Free Software Foundation; either version 2 of the License, or
       *  (at your option) any later version.
       *
       *  This program is distributed in the hope that it will be useful,
       *  but WITHOUT ANY WARRANTY; without even the implied warranty of
       *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       *  GNU General Public License for more details.
       *
       *  You should have received a copy of the GNU General Public License
       *  along with this program; if not, write to the Free Software
       *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
       *  USA.
       */ 

#include "cross.h"
#include "mem_test.h"

#define REPEAT10(x) x "" x "" x "" x "" x "" x "" x "" x "" x "" x
#define REPEAT50(x) REPEAT10(x) "" REPEAT10(x) "" REPEAT10(x) "" REPEAT10(x) "" REPEAT10(x)
#define REPEAT250(x) REPEAT50(x) "" REPEAT50(x) "" REPEAT50(x) "" REPEAT50(x) "" REPEAT50(x)
#define REPEAT1000(x) REPEAT250(x) "" REPEAT250(x) "" REPEAT250(x) "" REPEAT250(x)
#define REPEAT5000(x) REPEAT1000(x) "" REPEAT1000(x) "" REPEAT1000(x) "" REPEAT1000(x) "" REPEAT1000(x) 
#define REPEAT10000(x) REPEAT5000(x) "" REPEAT5000(x)

#define min(a,b)        ((a) < (b) ? (a): (b))

long temp;

#pragma align 16


int nop_test()
{

}

int shr_test()
{
	asm volatile(REPEAT10000("shr $1, %eax;"));

}

int ror_test()
{
	asm volatile(REPEAT10000("ror $1, %eax;"));

}


int mov1_test()
{
	asm volatile(REPEAT10000("mov 	$1686586, %eax;"));

}

int mov2_test()
{
	asm volatile(REPEAT10000("mov 	%ebx, %eax;"));

}

int add_test()
{
	asm volatile(REPEAT10000("add 	%ebx, %eax;"));

}

#if defined(__i386__)
int mul_test()
{
	asm volatile("push 	%edx;");
	asm volatile("push 	%ebx;");
	asm volatile("mov 	$3, %ebx");
	asm volatile("mov 	$145612, %eax");
	asm volatile(REPEAT10000("mul 	%ebx;"));
	asm volatile("pop 	%ebx;");
	asm volatile("pop 	%edx;");

}
#endif
long inc_test(){
	asm volatile(REPEAT10000("inc %eax;"));
	//asm(REPEAT10000("pop eax;"));
}

long jmp_test(){
	asm volatile(REPEAT10000("nop;"));
	//asm(REPEAT10000("pop eax;"));
}



//need a better!!!
#ifdef __WIN32__

#else

long getTickCount()
{
    tms tm;
    return times(&tm)*10;
}

#endif


void display_res(long inp)
{
	printf("%g\n",double(int((double(inp)/10000.0+1.0/12.0)*6.0))/6.0);	//some rounding
}


cmem::cmem ()
{
	//nothing here
}

#define MEMCOPY 1
#define MEMSET 2
#define MEMCMP 3
#define TIMELEN 1000
int mem_test(int block, int type){
	char * buffer;
	char * buffer2;
	buffer = (char*) malloc (block);
	buffer2 = (char*) malloc (block);
  	if ((buffer==NULL) || (buffer2==NULL)) {
		printf("Lack of supply!\n");
		exit (1);
		}

	memset(buffer,0,block);	
	memset(buffer2,0,block);	

	#ifdef __WIN32__
	time_t timeStop, timeStart;
    	timeStart = time (NULL);	
	#else
	int timeStop, timeStart;
	tms tm;
    	timeStart = times(&tm)*10;
	#endif	

	long read = 0;
	register int r;
	for (;;){
		#ifdef __WIN32__
		timeStop = time (NULL);
		#else
  		timeStop = times(&tm)*10;
		#endif
  		if ((int)(timeStop - timeStart) > 0) break;
		}

	for (;;){
		#ifdef __WIN32__
		timeStop = time (NULL);
		#else
  		timeStop = times(&tm)*10;
		#endif
 		#ifdef __WIN32__
	  	if ((int)(timeStop - timeStart) > (TIMELEN/1000)) break;
		#else
	  	if ((int)(timeStop - timeStart) > TIMELEN) break;
		#endif

		read+=32;
		if (type==MEMCOPY)
  			for (int k=0; (k<(32*1024*1024/block));k++)
				memcpy(buffer,buffer2,block);	

		if (type==MEMSET)
  			for (int k=0; (k<(32*1024*1024/block));k++)
				memset(buffer,0,block);	
	
		}

	free (buffer);
	free (buffer2);	

	return (read/(TIMELEN/1000));
}


void cmem::mem_speed_test ()
{
	printf("\n------=[Memory transfer speed test]=----------------------------------\n");
	
	printf("\n");
	printf("Write speed (by memset) : %d Mb/s \n",mem_test(1024 * 1024,MEMSET));
	printf("Repeated copy (by memcpy) of data blocks\n");
	int nl=0;
	printf("block size     speed:    block size:   speed:\n");
//		    2 Kb     3872 Mb/s        4 Kb     1440 Mb/s  
	for (int b=2048;(b<(32*1024*1024));b*=2){
		nl++;
		if (b<1024*1024)
			printf("%5d Kb %8d Mb/s  ",b / 1024,mem_test(b,MEMCOPY));
		else	
			printf("%5d Mb %8d Mb/s  ",b / 1024 / 1024,mem_test(b,MEMCOPY));
		if (nl%2==0) printf("\n");
		}
}



long GetTicks(){
	return rdtsc();
}
#define INSTR_TEST_CCOUNT 7

void cmem::instr_test ()
{
	printf("\n------=[Instruction latency meter (experimental)]=--------------------\n");

	
	printf("\n");
	long t1, t2, t3;
	t3=10000000;
	
//	t2=10000000;
	
	for (int i=0;i<1000;i++){
		t1=GetTicks();
		nop_test();
		t3=min(GetTicks()-t1, t3);
		}

	for (int test=0; test<INSTR_TEST_CCOUNT; test++) {
		t2=10000000;
		switch (test) {
			case 0:{ 
				printf("SHR r32, i8:  "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					shr_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			case 1:{ 
				printf("ROR r32, i8:  "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					ror_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			case 2:{ 
				printf("MOV r32, r32: "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					mov2_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			case 3:{ 
				printf("ADD r32, r32: "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					add_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			#if defined(__i386__)
			case 4:{ 
				printf("MUL r32, r32: "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					mul_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			#endif
			case 5:{ 
				printf("INC r32:      "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					inc_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
			case 6:{ 
				printf("NOP:          "); 
				for (int i=0;i<10000;i++){
					t1=GetTicks();	
					jmp_test();
					t2=min(t2,GetTicks()-t1);
					}
				display_res(t2-t3);
				break;
				}
		}	
	}

}
